import es
import soccer.soccer as soccerlib
import playerlib
import cmdlib
import random
import nativetools
import time
import urllib
from gamethread import delayed
from os import path
from cPickle import dump

info = es.AddonInfo()
info.name = "Soccer Stats Script"
info.version = soccerlib.info.version
info.basename = "soccerstats"
info.author = "chrismrulz"

soccerlib.restrictstat('Name')
soccerlib.restrictstat('Steals')
soccerlib.restrictstat('Team-Kills')
commentator = int(soccerlib.config["Commentator"]["enabled"])
misses = int(soccerlib.config["Commentator"]["misses"])
goals = int(soccerlib.config["Commentator"]["goals"])
assists = int(soccerlib.config["Commentator"]["assists"])
saves = int(soccerlib.config["Commentator"]["saves"])
passes = int(soccerlib.config["Commentator"]["passes"])
possessions = int(soccerlib.config["Commentator"]["possessions"])
steals = int(soccerlib.config["Commentator"]["steals"])
tackles = int(soccerlib.config["Commentator"]["tackles"])
interceptions = int(soccerlib.config["Commentator"]["interceptions"])
kills = int(soccerlib.config["Commentator"]["kills"])
deathgoals = int(soccerlib.config["Stats"]["deathgoals"])
autoupdateaddress = soccerlib.config["Stats"]["autoupdateaddress"]
autoupdatepassword = soccerlib.config["Stats"]["autoupdatepassword"]
goalhp = soccerlib.goalhp
goalxm = soccerlib.goalxm
goalxp = soccerlib.goalxp
tgoalym = soccerlib.tgoalym
tgoalyp = soccerlib.tgoalyp
ctgoalym = soccerlib.ctgoalym
ctgoalyp = soccerlib.ctgoalyp
halfline = soccerlib.halfline
ballname = soccerlib.ballname
handles = []
pstatsfile = es.getAddonPath('soccer') + '/playerstats.cpickle'
if(path.exists(pstatsfile)):
	from cPickle import load
	readpstats = open(pstatsfile, 'r')
	soccerlib.stats = load(readpstats)
	readpstats.close()

def load():
	es.msg('#Green', 'Soccer Stats Script On - by Toph')
	loadblock()

def unload():
	cmdlib.unregisterClientCommand('stats')
	cmdlib.unregisterClientCommand('resetstats')
	cmdlib.unregisterSayCommand('!stats')
	cmdlib.unregisterSayCommand('!resetstats')
	delhandles()
	es.msg('#Green', 'Soccer Stats Script Off')

def es_map_start(event_var):
	loadblock()

def loadblock():
	if(es.exists('clientcommand', 'showstats') != 1):
		cmdlib.registerClientCommand('showstats', stats, 'Shows the player options menu')
	if(es.exists('clientcommand', 'resetstats') != 1):
		cmdlib.registerClientCommand('resetstats', resetstats, 'Shows the player options menu')
	if(es.exists('saycommand', '!stats') != 1):
		cmdlib.registerSayCommand('!stats', stats, 'Shows the player options menu')
	if(es.exists('saycommand', '!resetstats') != 1):
		cmdlib.registerSayCommand('!resetstats', resetstats, 'Shows the player options menu')

def miss():
	if(soccerlib.roundfinished != 1):
		if(allowmiss == 1):
			ballvec = es.getindexprop(es.getentityindex('func_physbox'), 'CPhysBox.baseclass.m_vecOrigin').split(',')
			ballx = float(ballvec[0])
			bally = float(ballvec[1])
			if(bally < halfline and ltteam == 2):
				domiss()
			elif(bally > halfline and ltteam == 3):
				domiss()

def setallowmiss(allow):
	global allowmiss
	allowmiss = allow

def domiss():
	global misssteamid
	global missname
	misssteamid = ltsteamid
	missname = ltname
	setallowmiss(0)
	delayed(7, setallowmiss, (1))

def checkmiss():
	if(misssteamid):
		global misssteamid
		global missname
		soccerlib.incstat(misssteamid, missname, 'Misses')
		if(commentator == 1 and misses == 1):
			es.msg('#multi', '#greenPlayer#lightgreen %s #greenmissed the goal.' % ltname)
		misssteamid = None
		missname = None

def stats(userid, args):
	if(len(args) == 0):
		steamid = es.getplayersteamid(userid)
	else:
		steamid = es.getplayersteamid(es.getuserid(args[0]))
	if(steamid not in soccerlib.stats):
		es.menu(0, userid, 'No stats currently on record for the user.')
	else:
		menu = '[ %s ]' % soccerlib.stats[steamid]['Name']
		for stat in soccerlib.stats[steamid]:
			statval = soccerlib.stats[steamid][stat]
			if(stat == 'PlayTime'):
				menu += '\nHours Played: %.1f' % (statval * 0.000277777778)
			elif(stat != 'Name' and stat != 'Joined'):
				menu += '\n%s: %s' % (stat, statval)
		es.menu(0, userid, menu)

def resetstats(userid, args):
	steamid = es.getplayersteamid(userid)
	if(steamid not in soccerlib.stats):
		es.menu(0, userid, 'No stats currently on record for the user.')
	else:
		for stat in soccerlib.stats[steamid]:
			if(stat not in soccerlib.stats['@Restricted']):
				soccerlib.stats[steamid][stat] = 0
		es.menu(0, userid, 'Your stats have been reset.')

def player_changename(event_var):
	steamid = event_var['es_steamid']
	if(steamid not in soccerlib.stats):
		soccerlib.stats[steamid] = {}
	soccerlib.stats[steamid]['Name'] = event_var['newname']

def player_spawn(event_var):
	dojoin(event_var['es_steamid'], event_var['es_username'])

def dojoin(steamid, name):
	if(steamid not in soccerlib.stats):
		soccerlib.stats[steamid] = {}
		soccerlib.stats[steamid]['Name'] = name
	if('Joined' not in soccerlib.stats[steamid]):
		soccerlib.stats[steamid]['Joined'] = time.time()

def player_disconnect(event_var):
	if(event_var['networkid'] != 0 and event_var['name'] != 0):
		getplayertime(event_var['networkid'], event_var['name'])

def player_death(event_var):
	getplayertime(event_var['es_steamid'], event_var['es_username'])
	soccerlib.incstat(event_var['es_steamid'], event_var['es_username'], 'Deaths')

def getplayertime(steamid, name):
	dojoin(steamid, name)
	if('PlayTime' not in soccerlib.stats[steamid]):
		soccerlib.stats[steamid]['PlayTime'] = (time.time() - soccerlib.stats[steamid]['Joined'])
	else:
		soccerlib.stats[steamid]['PlayTime'] += (time.time() - soccerlib.stats[steamid]['Joined'])
	del soccerlib.stats[steamid]['Joined']

def savestats():
	savestatdb()
	if(autoupdateaddress != ""):
		urllib.urlopen('%s?password=%s' % (autoupdateaddress, autoupdatepassword))

def savestatdb():
	writestatvars = open(pstatsfile, 'w')
	dump(soccerlib.stats, writestatvars)
	writestatvars.close()

def delhandles():
	global handles
	nativetools.unregisterHandles(handles)
	del handles[:]

def round_end(event_var):
	delhandles()
	savestats()

def server_shutdown(event_var):
	savestats()

def round_start(event_var):
	delhandles()
	doingsave = 0
	rp = random.choice(playerlib.getUseridList('#alive'))
	handles.append(nativetools.touchRegister(es.getentityindex('func_physbox'), touch_callback, True, "player"))
	soccerlib.dofire(rp, 'trigger_multiple', 'addoutput \"ontrigger point_servercommand,command,es_xdoblock soccer/soccerstats/miss\"')
	nrtime = time.time()
	if(deathgoals == 1):
		global donedeadround
		donedeadround = 0
	setallowmiss(1)
	global misssteamid
	global missname
	global ltuserid
	global ltsteamid
	global ltname
	global ltteam
	global lasteamid
	global laname
	global lateam
	global lssteamid
	global lsname
	#global lksteamid
	#global lkname
	misssteamid = None
	missname = None
	ltuserid = None
	ltsteamid = None
	ltname = None
	ltteam = None
	lasteamid = None
	laname = None
	lateam = None
	lssteamid = None
	lsname = None
	#lksteamid = None
	#lkname = None

def touch_callback(index, touched):
		if(soccerlib.roundfinished != 1):
			userid = nativetools.getUseridByIndex(touched)
			player = playerlib.getPlayer(userid)
			steamid = player.steamid
			name = player.name
			team = player.team
			if(userid != ltuserid and ltuserid != None):
				ballvec = es.getindexprop(index, 'CPhysBox.baseclass.m_vecOrigin').split(',')
				ballx = float(ballvec[0])
				bally = float(ballvec[1])
				playerloc = es.getplayerlocation(userid)
				ballownerx = playerloc[0]
				ballownery = playerloc[1]
				dopossess(steamid, name)
				if(team == 2 and closetogoal(ballx, bally, tgoalyp, tgoalym)):
					dosave(steamid, name)
				elif(team == 3 and closetogoal(ballx, bally, ctgoalyp, ctgoalym)):
					dosave(steamid, name)
				if(team == ltteam):
					dosteal(player, steamid, name)
				elif(team == 2):
					doattack(player.getClosestPlayer(3), steamid, name)
				else:
					doattack(player.getClosestPlayer(2), steamid, name)
			elif(ltuserid == None):
				dopossess(steamid, name)
			global ltuserid
			global ltsteamid
			global ltname
			global ltteam
			ltuserid = userid
			ltsteamid = steamid
			ltname = name
			ltteam = team

def closetogoal(ballx, bally, yp, ym):
	if(ballx < goalxp and bally < yp and ballx > goalxm and bally > ym):
		return True
	else:
		return False

def dosave(steamid, name):
	global lssteamid
	global lsname
	lssteamid = steamid
	lsname = name

def checksave():
	if(lssteamid):
		global lssteamid
		global lsname
		soccerlib.incstat(lssteamid, lsname, 'Saves')
		if(commentator == 1 and saves == 1):
			es.msg('#multi', '#greenPlayer#lightgreen %s #greensaved the goal.' % lsname)
		lssteamid = None
		lsname = None

def dopass(name):
	global lasteamid
	global laname
	global lateam
	lasteamid = ltsteamid
	laname = ltname
	lateam = ltteam
	soccerlib.incstat(ltsteamid, ltname, 'Passes')
	if(commentator == 1 and passes == 1):
		es.msg('#multi', '#greenPlayer#lightgreen %s #greenpassed the ball to player#lightgreen %s' % (ltname, name))
	
def dopossess(steamid, name):
	checksave()
	checkmiss()
	soccerlib.incstat(steamid, name, 'Possessions')
	if(commentator == 1 and possessions == 1):
		es.msg('#multi', '#greenPlayer#lightgreen %s #greenhas possession of the ball.' % name)

def dosteal(player, steamid, name):
	if(player.getDistance(ltuserid) < 300):
		soccerlib.incstat(steamid, name, 'Steals')
		if(commentator == 1 and steals == 1):
			es.msg('#multi', '#greenPlayer#lightgreen %s #greenstole the ball off player#lightgreen %s' % (name, ltname))
	else:
		dopass(name)

def doattack(closest, steamid, name):
	if(closest[0] < 300):
		soccerlib.incstat(steamid, name, 'Tackles')
		if(commentator == 1 and tackles == 1):
			es.msg('#multi', '#greenPlayer#lightgreen %s #greentackled player#lightgreen %s' % (name, es.getplayername(closest[1])))
	else:
		soccerlib.incstat(steamid, name, 'Interceptions')
		if(commentator == 1 and interceptions == 1):
			es.msg('#multi', '#greenPlayer#lightgreen %s #greenintercepted the ball from player#lightgreen %s' % (name, ltname))

def player_hurt(event_var):
	if(event_var['weapon'] != 'knife'):
		if(int(event_var['dmg_health']) == goalhp and soccerlib.roundfinished == 0):
			goaltrig(int(event_var['es_userteam']))
		elif(int(event_var['dmg_health']) > goalhp):
			if(deathgoals == 1 and donedeadround == 0 and soccerlib.roundfinished == 1):
				global donedeadround
				donedeadround = 1
				goaltrig(int(event_var['es_userteam']))
			if(lateam == int(event_var['es_userteam'])):
				soccerlib.incstat(lasteamid, laname, 'Team-Kills')
				if(commentator == 1 and kills == 1):
					es.msg('#multi', '#greenPlayer#lightgreen %s #greenteam-killed player %s' % (laname, ltname))
			#elif(lksteamid == event_var['es_steamid']):
			#	soccerlib.incstat(lksteamid, lkname, 'Self-Kills')
			#	if(commentator == 1 and kills == 1):
			#		es.msg('#multi', '#greenPlayer#lightgreen %s #greenwas self-killed.' % lkname)
			#else:
			#	soccerlib.incstat(lksteamid, lkname, 'Kills')
			#	if(commentator == 1 and kills == 1):
			#		es.msg('#multi', '#greenPlayer#lightgreen %s #greenkilled player %s' % (lkname, event_var['es_username']))

def goaltrig(team):
	if(ltsteamid):
		if(ltteam == team):
			soccerlib.incstat(ltsteamid, ltname, 'OwnGoals')
			if(commentator == 1 and goals == 1):
				es.msg('#multi', '#greenPlayer#lightgreen %s #greenscored an own-goal.' % ltname)
			if(lateam == team):
				if(commentator == 1 and assists == 1):
					es.msg('#multi', '#greenPlayer#lightgreen %s #greenassisted the goal for the opposite team.' % laname)
		else:
			soccerlib.incstat(ltsteamid, ltname, 'Goals')
			if(commentator == 1 and goals == 1):
				es.msg('#multi', '#greenPlayer#lightgreen %s #greenscored.' % ltname)
			if(lasteamid and lateam != team):
				soccerlib.incstat(lasteamid, laname, 'Assists')
				if(commentator == 1 and assists == 1):
					es.msg('#multi', '#greenPlayer#lightgreen %s #greenassisted the goal.' % laname)